﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using System.Diagnostics;

namespace DarkNeuron.Services.Input
{
// #if !xbox
	public class ButtonKeyboard : Button
	{
		protected Keys key;
		public Keys Key { get { return key; } set { Console.WriteLine("ButtonKeyboard|Information:> Button key changed from {0} to {1}.", key, value); key = value;  } }


		public ButtonKeyboard(string name, Keys key)
			: base(name, ButtonDevice.Keyboard)
		{
			Console.WriteLine("ButtonKeyboard|Information:> New ButtonKeyboard \"{0}\" is being initialized...", Name);

			bool pass = true;
			this.key = key;

			pass = ButtonManager.AddButton(this);

			if (pass) Console.WriteLine("ButtonKeyboard|Information:> ButtonKeyboard \"{0}\" initialized successfully.", Name);
			else Console.WriteLine("ButtonKeyboard|Error:> ButtonKeyboard \"{0}\" is NOT successfully initialized!", Name);
		}


		public override void Update(GameTime gameTime)
		{
			if (Enabled)
			{
				// Sets current button states
				previousButtonState = currentButtonState;
				currentButtonState = GameInput.Keyboard.IsKeyDown(key) ? ButtonState.Down : ButtonState.Up;
			}


			base.Update(gameTime);
		}
	}
// #endif
}
